package com.convenient.android.lib.ui.ad

import android.os.Bundle
import android.util.Log
import androidx.activity.compose.setContent
import androidx.appcompat.app.AppCompatActivity
import androidx.lifecycle.lifecycleScope
import com.composition.android.ad.admob.impl.AdmobInitialize
import com.composition.android.ad.applovinmax.impl.AppLovinMaxInitialize
import com.composition.android.ad.gromore.impl.GroMoreInitialize
import com.composition.android.lib.ad.AdLoad
import com.composition.android.lib.ad.AdManager
import com.composition.android.lib.ad.basic.AdResult
import com.composition.android.lib.ad.util.adLogWithFrame
import com.convenient.android.common.extension.readyGo
import com.convenient.android.common.utils.ToastUtil
import com.convenient.android.lib.ui.ad.activity.AppWelcomeActivity
import com.convenient.android.lib.ui.ad.model.Datas
import com.convenient.android.lib.ui.ad.page.AdMainPage
import com.convenient.android.lib.ui.theme.SampleTheme
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch

class AdMainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContent {
            SampleTheme {
                AdMainPage()
            }
        }
        initAd()
    }

    private fun initAd() {
        AdManager.instance.init(applicationContext, true)
        AdManager.instance.initAdvertisersSDK(applicationContext, AdmobInitialize(), GroMoreInitialize("5089223"), AppLovinMaxInitialize())
        AdManager.instance.addGlobalAdShowListener {
            adLogWithFrame(
                tag = "广告全局展示监听", msgs = arrayOf(
                    "广告位名称：${it.adSlotName}",
                    "广告商:${it.advertisersName}",
                    "广告id:${it.adUnitId}",
                    "广告类型:${it.adType}"
                )
            )
        }
    }
}