package com.convenient.android.lib.ui.ad.viewmodel

import androidx.compose.runtime.mutableStateOf
import androidx.lifecycle.ViewModel
import com.composition.android.lib.ad.AdManager
import com.composition.android.lib.ad.basic.Advertisers
import com.composition.android.lib.ad.bean.AdUnitBean
import com.convenient.android.lib.ui.ad.model.Datas

/**
 * @classname:
 * @author: LiuXiaoLong
 * @date: 2022/9/5
 * description:
 */
class AdConfigViewModel : ViewModel() {

    var advertisers = mutableStateOf(Advertisers.UNKNOWN)

    fun changeRegisterAdvertisers(advertisers: Advertisers) {
        if (this.advertisers.value == advertisers) {
            this.advertisers.value = Advertisers.UNKNOWN
        } else {
            this.advertisers.value = advertisers
        }
        AdManager.instance.getAdUnitManager().setAdUnits(getAdUnits(this.advertisers.value))
    }

    fun getAdUnits(advertisers: Advertisers) : List<AdUnitBean> {
        return when (advertisers) {
            Advertisers.Admob -> Datas.AdmobAdUnitList
            Advertisers.CSJ -> Datas.CSJAdUnitList
            Advertisers.GroMore -> Datas.GroMoreAdUnitList
            Advertisers.AppLovinMax -> Datas.AppLovinMaxAdUnitList
            else -> emptyList()
        }
    }
}