package com.composition.android.lib.ad.bean

import java.io.Serializable

/**
 * @classname:AdDetail
 * @author: LiuXiaoLong
 * @date: 2023/7/17
 * description: 自定义广告素材详情内容
 * @param jumpOver 广告是否可跳过
 * @param countDown 倒计时时间， 单位：秒
 * @param pic : 广告图片素材，会按照语言编码存在多组素材数据， 优先级 以【简体中文—中国】为例， 优先级为：zh_rCN-> zh -> en
 */
data class AdDetail(
    var jumpOver: Boolean = true,
    var countDown: Int = 5,
    var pic: Map<String, AdDetailPic> = mutableMapOf()
) : Serializable

/**
 * 广告素材详情内容
 * @param language 素材对应的语言编码
 * @param ratio 图片素材尺寸比例 举例： 0.5  则为 宽高 1：0.5
 * @param imageUrl 图片素材链接
 * @param link 跳转的链接
 * @param jumpApp 链接是否为跳转如app内部uri
 */
data class AdDetailPic(
    var language: String,
    var ratio: Double,
    var imageUrl: String,
    var link: String,
    var jumpApp: Boolean
) : Serializable