package com.composition.android.lib.ad.interfaces

import android.content.Context
import com.composition.android.lib.ad.util.px2dip


/**
 * @classname:
 * @author: LiuXiaoLong
 * @date: 2022/10/25
 * description: 广告尺寸
 * @param widthPx 广告view宽度
 * @param heightPx 广告view 高度
 * @param autoSize 自适应尺寸，仅admob可用
 */
data class AdSize(
    var widthPx: Int,
    var heightPx: Int,
    var autoSize: Boolean = false
) {

    fun isAvailable(): Boolean {
        return (widthPx > 0 && heightPx > 0) || autoSize
    }

    fun getWidthDp(context: Context) : Int{
        return px2dip(context, widthPx.toFloat())
    }

    fun getHeightDp(context: Context) : Int{
        return px2dip(context, heightPx.toFloat())
    }
}