package com.composition.android.ad.custom.load.request

import android.content.Context
import com.composition.android.lib.ad.basic.AdLoadCode
import com.composition.android.lib.ad.basic.AdResult
import com.composition.android.lib.ad.bean.AdUnitBean
import com.composition.android.lib.ad.interfaces.IAdFormatRequest
import java.util.Locale

/**
 * @classname:
 * @author: LiuXiaoLong
 * @date: 2023/7/17
 * description:
 */
abstract class BasicCustomRequestImpl : IAdFormatRequest {

    abstract fun name() : String

    override suspend fun load(context: Context, adUnitBean: AdUnitBean): AdResult {
        if (adUnitBean.adDetail == null){
            return AdResult.Fail(adBean = adUnitBean, code = AdLoadCode.FAIL, msg = "${name()}-开屏-adDetail为空")
        }
        val systemLanguageTag = Locale.getDefault().toLanguageTag()
        var adDetail = adUnitBean.adDetail
        var picDetail = adDetail?.pic?.get(systemLanguageTag)
        if (picDetail == null){
            picDetail = adDetail?.pic?.get("en")
        }
        if (picDetail == null){
            return AdResult.Fail(adBean = adUnitBean, code = AdLoadCode.FAIL, msg = "${name()}-开屏-pic广告图片素材数据为空")
        }
        return AdResult.Success(adObject = null, adBean = adUnitBean, msg = "${name()}-开屏-加载成功")
    }
}