package com.convenient.android.common.base.viewbinding

import android.content.Context
import android.view.LayoutInflater
import androidx.annotation.StyleRes
import androidx.viewbinding.ViewBinding
import com.google.android.material.bottomsheet.BottomSheetDialog

/**
 * @classname: BaseBindingBottomSheetDialog
 * @author: LiuXiaoLong
 * @date: 2022-07-27 PM
 * description:
 */
abstract class BaseBindingBottomSheetDialog<VB : ViewBinding>(inflate: (LayoutInflater) -> VB, context: Context, @StyleRes theme: Int) : BottomSheetDialog(context, theme) {

    var binding: VB = inflate(layoutInflater)

    init {
        setContentView(binding.root)
    }

}