package com.convenient.android.common.media

import android.net.Uri
import java.io.Serializable

/**
 * @classname:
 * @author: LiuXiaoLong
 * @date: 2022/8/2
 * description:媒体文件Bean
 */

/**
 * @param mediaPath 文件路径
 * @param name 文件名称
 * @param extension 文件格式
 * @param isFile 是否是文件
 * @param lastModified 文件最后修改时间
 * @param parentPath 所在的父文件夹路径
 * @param uri
 */
data class MediaBean(
    var mediaPath : String,
    var name : String,
    var extension : String,
    var isFile : Boolean,
    var lastModified : Long,
    var parentPath : String,
    var length : Long?= 0L,
    var uri : Uri? = null,
) : Serializable
