package com.kdanmobile.android.lib.material.tokens

import com.kdanmobile.android.lib.material.tokens.category.MdParseUtil


/**
 * 运行解析token, 生成对应文件
 * 目前只解析 global.json、alias-light.json
 *
 * 请注意一下问题：
 * comp-light.json 组合token未解析，过于太多， 具体使用时再手动解析比较节约时间
 *
 * global.json 中以下token类型为进行解析
 * text-mac : 字体token, 目前不太可能在安卓引入字体使用，没有解析，可以具体用的时候手动添加
 * shadow   : View阴影， 不太好解析生成
 * text-windows : 字体token, 理由同上
 *
 * alias-light.json 以下token类型未解析
 * shadow  : View阴影， 同上
 * text    : 字体token别名， 理由同上
 *
 *
 * 如果需要修改token保存后的文件保存名称请查看
 * @see com.kdanmobile.android.lib.material.tokens.category.ParseTokenFactory
 *
 *
 */
fun main() {

    //解析global.json token
    val globalTokenUtil = MdParseUtil(TokenJsonType.Global, "./lib_material_tokens/src/tokens/global.json","./lib_material_tokens/src/")
    globalTokenUtil.start()

    //解析alias-light.json token
    val aliasTokenParse = MdParseUtil(TokenJsonType.Alias, "./lib_material_tokens/src/tokens/alias-light.json","./lib_material_tokens/src/")
    aliasTokenParse.start()




}